<template>
  <div class="app-container-page">
    <el-form class="table-form-search" :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch"
      label-width="68px">
      <el-row>
        <el-col :span="8">
          <el-form-item label="设备ID" prop="deviceId">
            <el-input v-model="queryParams.deviceId" placeholder="请输入设备ID" clearable @keyup.enter="handleQuery" />
          </el-form-item>
        </el-col>
        <el-col :span="16" class="searchBtn">
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <div class="table-list">
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button type="primary" plain icon="Plus" @click="handleAdd"
            v-hasPermi="['worn:threshold:add']">新增</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
            v-hasPermi="['worn:threshold:edit']">修改</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
            v-hasPermi="['worn:threshold:remove']">删除</el-button>
        </el-col>
        <el-col :span="1.5">
          <el-button type="warning" plain icon="Download" @click="handleExport"
            v-hasPermi="['worn:threshold:export']">导出</el-button>
        </el-col>
        <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>

      <el-table v-loading="loading" :data="thresholdList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="主键ID" align="center" prop="id" />
        <el-table-column label="设备ID" align="center" prop="deviceId" />
        <el-table-column label="指标类型" align="center" prop="metricType" />
        <el-table-column label="预警最小值" align="center" prop="warnMin" />
        <el-table-column label="预警最大值" align="center" prop="warnMax" />
        <el-table-column label="报警最小值" align="center" prop="alarmMin" />
        <el-table-column label="报警最大值" align="center" prop="alarmMax" />
        <el-table-column label="单位" align="center" prop="unit" />
        <el-table-column label="状态" align="center" prop="status" />
        <el-table-column label="备注" align="center" prop="remark" />
        <!-- <el-table-column label="是否删除" align="center" prop="isDelete" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
              v-hasPermi="['worn:threshold:edit']">修改</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
              v-hasPermi="['worn:threshold:remove']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </div>
    <!-- 添加或修改传感器阈值配置对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="thresholdRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="设备ID" prop="deviceId">
          <el-input v-model="form.deviceId" placeholder="请输入设备ID" />
        </el-form-item>
        <el-form-item label="预警最小值" prop="warnMin">
          <el-input v-model="form.warnMin" placeholder="请输入预警最小值" />
        </el-form-item>
        <el-form-item label="预警最大值" prop="warnMax">
          <el-input v-model="form.warnMax" placeholder="请输入预警最大值" />
        </el-form-item>
        <el-form-item label="报警最小值" prop="alarmMin">
          <el-input v-model="form.alarmMin" placeholder="请输入报警最小值" />
        </el-form-item>
        <el-form-item label="报警最大值" prop="alarmMax">
          <el-input v-model="form.alarmMax" placeholder="请输入报警最大值" />
        </el-form-item>
        <el-form-item label="单位" prop="unit">
          <el-input v-model="form.unit" placeholder="请输入单位" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
        <!-- <el-form-item label="是否删除" prop="isDelete">
          <el-input v-model="form.isDelete" placeholder="请输入是否删除" />
        </el-form-item> -->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Threshold">
import { listThreshold, getThreshold, delThreshold, addThreshold, updateThreshold } from "@/api/worn/threshold"

const { proxy } = getCurrentInstance()

const thresholdList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    deviceId: null,
    metricType: null,
    warnMin: null,
    warnMax: null,
    alarmMin: null,
    alarmMax: null,
    unit: null,
    status: null,
    isDelete: null
  },
  rules: {
    deviceId: [
      { required: true, message: "设备ID不能为空", trigger: "blur" }
    ],
    metricType: [
      { required: true, message: "指标类型不能为空", trigger: "change" }
    ],
  }
})

const { queryParams, form, rules } = toRefs(data)

/** 查询传感器阈值配置列表 */
function getList() {
  loading.value = true
  listThreshold(queryParams.value).then(response => {
    thresholdList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  reset()
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    deviceId: null,
    metricType: null,
    warnMin: null,
    warnMax: null,
    alarmMin: null,
    alarmMax: null,
    unit: null,
    status: null,
    remark: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    isDelete: null
  }
  proxy.resetForm("thresholdRef")
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加传感器阈值配置"
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _id = row.id || ids.value
  getThreshold(_id).then(response => {
    form.value = response.data
    open.value = true
    title.value = "修改传感器阈值配置"
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["thresholdRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateThreshold(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addThreshold(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value
  proxy.$modal.confirm('是否确认删除传感器阈值配置编号为"' + _ids + '"的数据项？').then(function () {
    return delThreshold(_ids)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => { })
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('worn/threshold/export', {
    ...queryParams.value
  }, `threshold_${new Date().getTime()}.xlsx`)
}

getList()
</script>
